﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Controls;
using System.ComponentModel;
using System.Windows;
using System.Diagnostics;
using Infragistics;
using Infragistics.Controls.Charts;

namespace xamDataChart1
{
    public class ViewModel1 : INotifyPropertyChanged
    {
        public void UpdateLabel(XamDataChart xmDataChart)
        {
            StockMarketDataCollection stockMarketDataCollection = (StockMarketDataCollection)xmDataChart.DataContext;
            double left = xmDataChart.ViewportRect.Left;
            double right = xmDataChart.ViewportRect.Right;
            Axis xAxis = xmDataChart.Axes[0];
            double left2 = xAxis.GetUnscaledValue(left, new ScalerParams(xmDataChart.WindowRect, xmDataChart.ViewportRect, false));
            double left2Round = Math.Round(left2);
            double right2 = xAxis.GetUnscaledValue(right, new ScalerParams(xmDataChart.WindowRect, xmDataChart.ViewportRect, false));
            double right2Round = Math.Round(right2);
            if (!double.IsNaN(left2))
            {
                StockMarketDataPoint item = stockMarketDataCollection[(int)left2Round];
                StockMarketDataPoint item2 = stockMarketDataCollection[(int)right2Round];
                TimeSpan timeSpan = item2.Date - item.Date;
                if (timeSpan.Days < 365)
                {
                    Label = "{Date:dd MMM yyyy}";
                }
                else
                {
                    Label = "{Date:dd/MM/yyyy}";
                }
            }
        }

        public void OnZoomChanged(object sender, ZoomChangedEventArgs e)
        {
            Rect rect = Rect;
            rect.X = Range.Minimum;
            rect.Width = (Range.Maximum - Range.Minimum);
            Rect = rect;
        }

        private string _label = "{Date:dd/MM/yyyy}";
        public string Label
        {
            get
            {
                return _label;
            }
            set
            {
                _label = value;
                OnPropertyChanged("Label");
            }
        }

        private Rect _rect;
        public Rect Rect
        {
            get
            {
                if (_rect.Width == 0d)
                {
                    _rect.Y = 0;
                    _rect.Height = 1;
                    _rect.X = Range.Minimum;
                    _rect.Width = (Range.Maximum - Range.Minimum);
                }
                return _rect;
            }
            set
            {
                _rect = value;
                _range.Minimum = _rect.Left;
                _range.Maximum = _rect.Right;
                OnPropertyChanged("Rect");
            }
        }

        private Range _range;
        public Range Range 
        {
            get
            {
                if (_range == null)
                {
                    _range = new Infragistics.Controls.Range();
                    Label = "{Date:dd MMM yyyy}";
                }
                return _range;
            }
            set
            {
                _range = value;
                OnPropertyChanged("Range");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
